/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { SearchCategoryType } from '../../@coscine/model';
// @ts-ignore
import type { SearchResultDtoPagedSearchResponse } from '../../@coscine/model';
/**
 * SearchApi - axios parameter creator
 * @export
 */
export const SearchApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SearchOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/search`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a search result by given search parameters.
         * @param {string} [query] The search query
         * @param {boolean} [useAdvancedSyntax] Set true for advanced Elasticsearch search syntax
         * @param {Array<string>} [languages] Set the used languages
         * @param {SearchCategoryType} [category] Set the category filter
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getSearchResults: async (query?: string, useAdvancedSyntax?: boolean, languages?: Array<string>, category?: SearchCategoryType, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/search`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (query !== undefined) {
                localVarQueryParameter['Query'] = query;
            }

            if (useAdvancedSyntax !== undefined) {
                localVarQueryParameter['UseAdvancedSyntax'] = useAdvancedSyntax;
            }

            if (languages) {
                localVarQueryParameter['Languages'] = languages;
            }

            if (category !== undefined) {
                localVarQueryParameter['Category'] = category;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SearchApi - functional programming interface
 * @export
 */
export const SearchApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SearchApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2SearchOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2SearchOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SearchApi.apiV2SearchOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a search result by given search parameters.
         * @param {string} [query] The search query
         * @param {boolean} [useAdvancedSyntax] Set true for advanced Elasticsearch search syntax
         * @param {Array<string>} [languages] Set the used languages
         * @param {SearchCategoryType} [category] Set the category filter
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getSearchResults(query?: string, useAdvancedSyntax?: boolean, languages?: Array<string>, category?: SearchCategoryType, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SearchResultDtoPagedSearchResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getSearchResults(query, useAdvancedSyntax, languages, category, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SearchApi.getSearchResults']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * SearchApi - factory interface
 * @export
 */
export const SearchApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SearchApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SearchOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2SearchOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a search result by given search parameters.
         * @param {SearchApiGetSearchResultsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getSearchResults(requestParameters: SearchApiGetSearchResultsRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<SearchResultDtoPagedSearchResponse> {
            return localVarFp.getSearchResults(requestParameters.query, requestParameters.useAdvancedSyntax, requestParameters.languages, requestParameters.category, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getSearchResults operation in SearchApi.
 * @export
 * @interface SearchApiGetSearchResultsRequest
 */
export interface SearchApiGetSearchResultsRequest {
    /**
     * The search query
     * @type {string}
     * @memberof SearchApiGetSearchResults
     */
    readonly query?: string

    /**
     * Set true for advanced Elasticsearch search syntax
     * @type {boolean}
     * @memberof SearchApiGetSearchResults
     */
    readonly useAdvancedSyntax?: boolean

    /**
     * Set the used languages
     * @type {Array<string>}
     * @memberof SearchApiGetSearchResults
     */
    readonly languages?: Array<string>

    /**
     * Set the category filter
     * @type {SearchCategoryType}
     * @memberof SearchApiGetSearchResults
     */
    readonly category?: SearchCategoryType

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof SearchApiGetSearchResults
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof SearchApiGetSearchResults
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof SearchApiGetSearchResults
     */
    readonly orderBy?: string
}

/**
 * SearchApi - object-oriented interface
 * @export
 * @class SearchApi
 * @extends {BaseAPI}
 */
export class SearchApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchApi
     */
    public apiV2SearchOptions(options?: RawAxiosRequestConfig) {
        return SearchApiFp(this.configuration).apiV2SearchOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a search result by given search parameters.
     * @param {SearchApiGetSearchResultsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchApi
     */
    public getSearchResults(requestParameters: SearchApiGetSearchResultsRequest = {}, options?: RawAxiosRequestConfig) {
        return SearchApiFp(this.configuration).getSearchResults(requestParameters.query, requestParameters.useAdvancedSyntax, requestParameters.languages, requestParameters.category, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }
}

